; SPIRITUS SANCTUS OSC (2015) for realtime Android Csound - by Arthur B. Hunkins
; Requires Android OS 4.4.2 or higher, and Csound6.apk built on Csound6.05+
;   Also requires TouchOSC app:
;    https://play.google.com/store/apps/details?id=net.hexler.touchosc_a
; Run both Csound6 and TouchOSC on same Android device
; Open SpiritusOSC.touchosc in TouchOSC and this file in Csound6
; In SpiritusOSC layout (Settings), set OSC Host to 127.0.0.1,
;   and outgoing Port to 8000 (requires no internet connection)
; Set all touchosc sliders to 0, Start Csound6, then perform in TouchOSC. 
;   To select a TONESET, click a button from 1 to 6 at any time (default = 1). 
;   To select amount of random beat speed variation, click button 7 to 11
;    at any time (default = button 7 = 0).
;   In master amp mode, button 12 coopts slider5's control of tone 2's amp    
;   In case of audio glitches, reduce the value of sr (Sample Rate, see below)
;    progressively to 32000, 22050, 11025 or 8000 until glitching disappears.
<CsoundSynthesizer>
<CsOptions>

-odac -m0d --expression-opt -b512 -B2048

</CsOptions>
<CsInstruments>

sr      =	44100 ; Sample Rate
ksmps	=	100
nchnls  =       2

gichan  OSCinit 8000

	instr 1
   
gktset  init     1
k1      init     0
kans    OSClisten gichan, "/1/butt1", "f", k1
k1a     trigger  k1, .5, 0
        if k1a == 1 then
gktset  =        1
        endif
k2      init     0
kans    OSClisten gichan, "/1/butt2", "f", k2
k2a     trigger  k2, .5, 0
        if k2a == 1 then
gktset  =        2
        endif
k3      init     0
kans    OSClisten gichan, "/1/butt3", "f", k3
k3a     trigger  k3, .5, 0
        if k3a == 1 then
gktset  =        3
        endif
k4      init     0
kans    OSClisten gichan, "/1/butt4", "f", k4
k4a     trigger  k4, .5, 0
        if k4a == 1 then
gktset  =        4
        endif
k5      init     0
kans    OSClisten gichan, "/1/butt5", "f", k5
k5a     trigger  k5, .5, 0
        if k5a == 1 then
gktset  =        5
        endif
k6      init     0
kans    OSClisten gichan, "/1/butt6", "f", k6
k6a     trigger  k6, .5, 0
        if k6a == 1 then
gktset  =        6
        endif
gkstart changed  gktset
	if gkstart == 1 then
        reinit   reset
	endif
reset:
gitset  =        i(gktset)
	if gitset == 1 then
gi1a	= 	 0
gi1b 	= 	 .12	
gi1c 	= 	 .17	
gi1d 	= 	 .4
gi1e 	= 	 400
gi1f 	= 	 1
gi1g 	= 	 1
gi2a 	= 	 .6
gi2b 	= 	 400.25
	elseif gitset == 2 then
gi1a 	= 	 0	
gi1b 	= 	 .25	
gi1c 	= 	 .2	
gi1d 	= 	 .2
gi1e 	= 	 200
gi1f 	= 	 2
gi1g 	= 	 2
gi2a 	= 	 .3
gi2b 	=  	 200.125
	elseif gitset == 3 then
gi1a 	=	 0	
gi1b 	=	 .25	
gi1c 	=	 .2	
gi1d 	=	 .1
gi1e 	=	 133
gi1f 	=	 3
gi1g 	=	 2
gi2a 	=	 .15
gi2b 	=	 133.0833
	elseif gitset == 4 then
gi1a 	=	 0	
gi1b 	=	 .25	
gi1c 	=	 .2	
gi1d 	=	 .1
gi1e 	=	 100
gi1f 	=	 4
gi1g 	=	 3
gi2a 	=	 .15
gi2b 	=	 100.0625
	elseif gitset == 5 then
gi1a 	=	 .5	
gi1b 	=	 .8	
gi1c 	=	 .1	
gi1d 	=	 .2
gi2a 	=	 .3
gi2b 	=	 400.25
	elseif gitset == 6 then
gi1a 	=	 .5	
gi1b 	=	 .8	
gi1c 	=	 .1	
gi1d 	=	 .2
gi2a 	=	 .3
gi2b 	=	 400.25
        endif
        rigoto   continue	
gkamp   init     0
kans    OSClisten gichan, "/1/slider1", "f", gkamp
kamp    tab      gkamp * 511, 4
kamp    port     kamp, .2
gkampb  =        kamp
gktimb2 init     0
kans    OSClisten gichan, "/1/slider3", "f", gktimb2
ktimb2  port     gktimb2, .2
gkmod   init     0
kans    OSClisten gichan, "/1/slider4", "f", gkmod
kmod    =        (gkmod * 2) + .5 
gktimb  init     0
kans    OSClisten gichan, "/1/slider2", "f", gktimb
continue:
ktimb   =        (gktimb * (gi1b - gi1a)) + gi1a
ktimb   port     ktimb, .2
kmod2   rspline  0, gi1c, kmod, kmod * 2.5
kjit    jitter   gi1d, 100, 150
        if gitset < 5 then
aout    gbuzz    15000 * gkampb, gi1e + kjit, 50, gi1f, ktimb + (kmod2 * ktimb2), gi1g
        else
aout    vco2     15000 * gkampb, 400 + kjit, 4, ktimb + (kmod2 * ktimb2), 0, (gitset == 5? .25: .085)
        endif
        rireturn	
        outs     aout, aout * .6

        endin
        
        instr 2
        
krand   init     0
ktrack  init     0
kfreq3  init     0
kamp    init     0
gkamp2  init     0
kans    OSClisten gichan, "/1/slider5", "f", gkamp2
kamp    port     gkamp2, .2
gktimb3 init     0
kans    OSClisten gichan, "/1/slider6", "f", gktimb3
gktimb4 init     0
kans    OSClisten gichan, "/1/slider7", "f", gktimb4
ktimb2  port     gktimb4, .2
gkmod2  init     0
kans    OSClisten gichan, "/1/slider8", "f", gkmod2
kmod    =        (gkmod2 * 2) + .5 
kfreq   init     0
kans    OSClisten gichan, "/1/slider9", "f", kfreq
k1      init     0
kans    OSClisten gichan, "/1/butt7", "f", k1
k1a     trigger  k1, .5, 0
        if k1a == 1 then
kfreq3  =        0
        endif
k2      init     0
kans    OSClisten gichan, "/1/butt8", "f", k2
k2a     trigger  k2, .5, 0
        if k2a == 1 then
kfreq3  =        .25
        endif
k3      init     0
kans    OSClisten gichan, "/1/butt9", "f", k3
k3a     trigger  k3, .5, 0
        if k3a == 1 then
kfreq3  =        .5
        endif
k4      init     0
kans    OSClisten gichan, "/1/butt10", "f", k4
k4a     trigger  k4, .5, 0
        if k4a == 1 then
kfreq3  =        .75
        endif
k5      init     0
kans    OSClisten gichan, "/1/butt11", "f", k5
k5a     trigger  k5, .5, 0
        if k5a == 1 then
kfreq3  =        1
        endif
k6      init     0
kans    OSClisten gichan, "/1/butt12", "f", k6
k6a     trigger  k6, .5, 0
        if k6a == 1 then
ktrack  =        (ktrack == 0? 1: 0)
        endif
kfreq3a port     kfreq3, .2
kamp    =        (ktrack == 0? kamp: gkampb)
        if gkstart == 1 then
        reinit   reset
        endif
reset:        
ktimb   =        (gktimb3 * (gi1b - gi1a)) + gi1a
ktimb   port     ktimb, .2
kmod2   rspline  0, gi1c, kmod, kmod * 2.5
kfreq2  rspline  0, frac(gi2b) * 6, 1, 1.75
kjit    jitter   gi2a, 100, 150
        if gitset < 5 then
aout    gbuzz    15000 * kamp, gi2b + kjit + (kfreq * frac(gi2b) * 4) + (kfreq2 * kfreq3a), 50, gi1f, ktimb + (kmod2 * ktimb2), gi1g
        else
aout    vco2     15000 * kamp, gi2b + kjit + (kfreq * frac(gi2b) * 4) + (kfreq2 * kfreq3a), 4, ktimb + (kmod2 * ktimb2), 0, (gitset == 5? .25: .085)
        endif
        rireturn
        outs     aout * .6, aout

        endin

</CsInstruments>
<CsScore>

f1 0 16384 11 1
f2 0 16384 11 20 1 .01
f3 0 16384 11 50 1 .01
f4 0 512 16 0 512 .8 1

i1 0 3600
i2 0 3600
e

</CsScore>
</CsoundSynthesizer> 