; SPIRITUS SANCTUS 2OSC (2015) for realtime Android Csound - by Arthur B. Hunkins
; Requires Android OS 4.4.2 or higher, and Csound6.apk built on Csound6.05+
;   Also requires TouchOSC app:
;    https://play.google.com/store/apps/details?id=net.hexler.touchosc_a
; Run both Csound6 and TouchOSC on same Android device
; Open SpiritusSanctus2OSC.touchosc in TouchOSC and this file in Csound6
; In SpiritusSanctus2OSC layout (Settings), set OSC Host to 127.0.0.1,
;   and outgoing Port to 8000 (requires no internet connection)
; Set all touchosc sliders to 0, Start Csound6, then perform in TouchOSC. 
;   In case of audio glitches, reduce the value of sr (Sample Rate, see below)
;    progressively to 32000, 22050, 11025 or 8000 until glitching disappears.

<CsoundSynthesizer>
<CsOptions>

-odac -m0d --expression-opt -b512 -B2048

</CsOptions>
<CsInstruments>

sr      =	44100 ; Sample Rate
ksmps	=	100
nchnls  =       2

gichan  OSCinit 8000

	instr 1
   
gkamp   init     0
kans    OSClisten gichan, "/1/slider1", "f", gkamp
kamp    tab      gkamp * 511, 2
kamp    port     kamp * 12000, .2
gkampb  =        kamp
gkmul   init     0
kans    OSClisten gichan, "/1/slider2", "f", gkmul
kmul    =        
kmul    port     gkmul * .82, .2
gknh    init     0
kans    OSClisten gichan, "/1/slider3", "f", gknh
knh     =        (gknh * 16) + 4
knh     port     knh, .2
gklh    init     0
kans    OSClisten gichan, "/1/slider4", "f", gklh
gklh2   =        (gklh * 6.1) + 4
gkamp2  init     0
kans    OSClisten gichan, "/1/slider8", "f", gkamp2
kamp2   port     gkamp2 * .6, .2
gkamp2b =        kamp2
kamp2b  rspline  -gkamp2b, gkamp2b, .6 * gklh2, gklh2
aout    gbuzz    gkampb + (kamp2b * gkampb), 200, knh, gklh2, kmul, 1
        outs     aout, aout * .7
        
        endin
        
        instr 2
   
gkmul2  init     0
kans    OSClisten gichan, "/1/slider5", "f", gkmul2
kmul    port     gkmul2 * .82, .2
gknh2   init     0
kans    OSClisten gichan, "/1/slider6", "f", gknh2
knh     port     (gknh2 * 16) + 4, .2
gkfreq  init     0
kans    OSClisten gichan, "/1/slider7", "f", gkfreq
kfreq   port     gkfreq * .15, .2 
kamp2b  rspline  -gkamp2b, gkamp2b, .6 * gklh2, gklh2
aout    gbuzz    gkampb + (kamp2b * gkampb), 200.05 + kfreq, knh, gklh2, kmul, 1
        outs     aout * .7, aout
        
        endin

</CsInstruments>
<CsScore>

f1 0 16384 11 16 1 .012
f2 0 512 16 0 512 .8 1
i1 0 3600
i2 0 3600

</CsScore>
</CsoundSynthesizer> 