; SPIRITUS SANCTUS 2alt (2013) for realtime Android Csound - by Arthur B. Hunkins
; Requires Android OS 2.3 or higher, and Csound5a.apk, Csound6a.apk, Csound6b.apk or Csound6c.apk
;   Downloadable from http://www.arthunkins.com/Android_Csound_Apps.htm
;   Disable WiFi and other connections for maximum performance
;   Run one of the above Android Csound apps, and Browse to (Open) this file
;   If audio glitches remain, reduce the value of sr (Sample Rate,
;    see below) to 32000, 22050, 11025 or 8000 until glitching disappears.
;   Set all sliders to 0 prior to Start.

<CsoundSynthesizer>
<CsOptions>

-odac -m0d --expression-opt -b512 -B2048

</CsOptions>
<CsInstruments>

sr      =	44100 ; Sample Rate
ksmps	=	100
nchnls  =       2

	instr 1
   
gkamp	chnget   "slider1"
gkamp   tab      gkamp * 511, 2
gkamp   port     gkamp * 12000, .2
kmul	chnget   "slider2"
kmul    port     kmul * .82, .2
knh	chnget   "slider3"
knh     port     (knh * 16) + 4, .2
gklh    chnget   "slider4"
gklh    =        (gklh * 6.1) + 4
gkamp2  chnget   "slider8"
gkamp2  port     gkamp2 * .6, .2
kamp2   rspline  -gkamp2, gkamp2, .6 * gklh, gklh
kamp2   port     kamp2, .01 
aout    gbuzz    gkamp + (kamp2 * gkamp), 200, knh, gklh, kmul, 1
        outs     aout, aout * .7
        
        endin
        
        instr 2
   
kmul	chnget   "slider5"
kmul    port     kmul * .82, .2
knh	chnget   "slider6"
knh     port     (knh * 16) + 4, .2
kfreq   chnget   "slider7"
kfreq   port     kfreq * .15, .2 
kamp2   rspline  -gkamp2, gkamp2, .6 * gklh, gklh
kamp2   port     kamp2, .01 
aout    gbuzz    gkamp + (kamp2 * gkamp), 200.05 + kfreq, knh, gklh, kmul, 1
        outs     aout * .7, aout
        
        endin

</CsInstruments>
<CsScore>

f1 0 16384 11 16 1 .012
f2 0 512 16 0 512 .8 1
i1 0 3600
i2 0 3600

</CsScore>
</CsoundSynthesizer> 