; SPIRITUS SANCTUSalt (2013) for realtime Android Csound - by Arthur B. Hunkins
; Requires Android OS 2.3 or higher, and Csound5a.apk, Csound6a.apk, Csound6b.apk or Csound6c.apk
;   Downloadable from http://www.arthunkins.com/Android_Csound_Apps.htm
;   Disable WiFi and other connections for maximum performance
;   Run one of the above Android Csound apps, and Browse to (Open) this file
;   To select a TONESET, click a button from 1 to 6 at any time (default = 1). 
;   To select amount of random beat speed variation, click button 7 to 12
;    at any time (default = button 7 = 0).
;   In case of audio glitches, reduce the value of sr (Sample Rate, see below)
;    progressively to 32000, 22050, 11025 or 8000 until glitching disappears.
;   Set all sliders to 0 prior to Start.

<CsoundSynthesizer>
<CsOptions>

-odac -m0d --expression-opt -b512 -B2048

</CsOptions>
<CsInstruments>

sr      =	44100 ; Sample Rate
ksmps	=	100
nchnls  =       2

	instr 1
   
gktset  init     1
k1      chnget   "butt1"
k1a     trigger  k1, .5, 0
        if k1a == 1 then
gktset  =        1
        endif
k2      chnget   "butt2"
k2a     trigger  k2, .5, 0
        if k2a == 1 then
gktset  =        2
        endif
k3      chnget   "butt3"
k3a     trigger  k3, .5, 0
        if k3a == 1 then
gktset  =        3
        endif
k4      chnget   "butt4"
k4a     trigger  k4, .5, 0
        if k4a == 1 then
gktset  =        4
        endif
k5      chnget   "butt5"
k5a     trigger  k5, .5, 0
        if k5a == 1 then
gktset  =        5
        endif
k6      chnget   "butt6"
k6a     trigger  k6, .5, 0
        if k6a == 1 then
gktset  =        6
        endif
kstart  changed  gktset
	if kstart == 1 then
        event "i", -2, 0, 0
        event "i", -3, 0, 0
        event "i", 2, 0, -1
        event "i", 3, 0, -1
	endif

        endin

        instr 2
   
gitset  =      i(gktset)
	if gitset == 1 then
gi1a	= 	 0
gi1b 	= 	 .12	
gi1c 	= 	 .17	
gi1d 	= 	 .4
gi1e 	= 	 400
gi1f 	= 	 1
gi1g 	= 	 1
gi2a 	= 	 .6
gi2b 	= 	 400.25
	elseif gitset == 2 then
gi1a 	= 	 0	
gi1b 	= 	 .25	
gi1c 	= 	 .2	
gi1d 	= 	 .2
gi1e 	= 	 200
gi1f 	= 	 2
gi1g 	= 	 2
gi2a 	= 	 .3
gi2b 	=  	 200.125
	elseif gitset == 3 then
gi1a 	=	 0	
gi1b 	=	 .25	
gi1c 	=	 .2	
gi1d 	=	 .1
gi1e 	=	 133
gi1f 	=	 3
gi1g 	=	 2
gi2a 	=	 .15
gi2b 	=	 133.0833
	elseif gitset == 4 then
gi1a 	=	 0	
gi1b 	=	 .25	
gi1c 	=	 .2	
gi1d 	=	 .1
gi1e 	=	 100
gi1f 	=	 4
gi1g 	=	 3
gi2a 	=	 .15
gi2b 	=	 100.0625
	elseif gitset == 5 then
gi1a 	=	 .5	
gi1b 	=	 .8	
gi1c 	=	 .1	
gi1d 	=	 .2
gi2a 	=	 .3
gi2b 	=	 400.25
	elseif gitset == 6 then
gi1a 	=	 .5	
gi1b 	=	 .8	
gi1c 	=	 .1	
gi1d 	=	 .2
gi2a 	=	 .3
gi2b 	=	 400.25
        endif
gkamp	chnget   "slider1"
gkamp   port     gkamp, .2
gktimb  chnget   "slider2"
gktimb  =        (gktimb * (gi1b - gi1a)) + gi1a
gktimb  port     gktimb, .2
gktimb2 chnget   "slider3"
gktimb2 port     gktimb2, .2
gkmod   chnget   "slider4"
gkmod   =        (gkmod * 2) + .5 
kmod2   rspline  0, gi1c, gkmod, gkmod * 2.5
kjit    jitter   gi1d, 100, 150
        if gitset < 5 then
aout    gbuzz    15000 * gkamp, gi1e + kjit, 50, gi1f, gktimb + (kmod2 * gktimb2), gi1g
        else
aout    vco2     15000 * gkamp, 400 + kjit, 4, gktimb + (kmod2 * gktimb2), 0, (gitset == 5? .25: .085)
        endif
        outs     aout, aout * .6

        endin
        
        instr 3
        
krand   init     0
ktrack  init     0
kfreq3  init     0
kamp    chnget   "slider5"
kamp    port     kamp, .2
ktimb   chnget   "slider6"
ktimb   =        (ktimb * (gi1b - gi1a)) + gi1a
ktimb   port     ktimb, .2
ktimb2  chnget   "slider7"
ktimb2  port     ktimb2, .2
kmod    chnget   "slider8"
kmod    =        (kmod * 2) + .5 
kmod2   rspline  0, gi1c, kmod, kmod * 2.5
kfreq   chnget   "slider9"
kfreq2  rspline  0, frac(gi2b) * 6, 1, 1.75
k1      chnget   "butt7"
k1a     trigger  k1, .5, 0
        if k1a == 1 then
kfreq3  =        0
        endif
k2      chnget   "butt8"
k2a     trigger  k2, .5, 0
        if k2a == 1 then
kfreq3  =        .25
        endif
k3      chnget   "butt9"
k3a     trigger  k3, .5, 0
        if k3a == 1 then
kfreq3  =        .5
        endif
k4      chnget   "butt10"
k4a     trigger  k4, .5, 0
        if k4a == 1 then
kfreq3  =        .75
        endif
k5      chnget   "butt11"
k5a     trigger  k5, .5, 0
        if k5a == 1 then
kfreq3  =        1
        endif
k6      chnget   "butt12"
k6a     trigger  k6, .5, 0
        if k6a == 1 then
ktrack  =        (ktrack == 0? 1: 0)
        endif
kfreq3a port     kfreq3, .2
kjit    jitter   gi2a, 100, 150
kamp2   =        gkamp
kamp    =        (ktrack == 0? kamp: kamp2)
        if gitset < 5 then
aout    gbuzz    15000 * kamp, gi2b + kjit + (kfreq * frac(gi2b) * 4) + (kfreq2 * kfreq3a), 50, gi1f, ktimb + (kmod2 * ktimb2), gi1g
        else
aout    vco2     15000 * kamp, gi2b + kjit + (kfreq * frac(gi2b) * 4) + (kfreq2 * kfreq3a), 4, ktimb + (kmod2 * ktimb2), 0, (gitset == 5? .25: .085)
        endif
        outs     aout * .6, aout

        endin

</CsInstruments>
<CsScore>

f1 0 16384 11 1
f2 0 16384 11 20 1 .01
f3 0 16384 11 50 1 .01
i1 0 3600
i2 0 -1
i3 0 -1

</CsScore>
</CsoundSynthesizer> 